summary refs log tree commit diff
path: root/pkgs/build-support/fetchbzr
diff options
context:
space:
mode:
authorRob Vermaas <rob.vermaas@gmail.com>2011-02-08 13:09:17 +0000
committerRob Vermaas <rob.vermaas@gmail.com>2011-02-08 13:09:17 +0000
commit224ff6c1eee1e282465b2a715e3f9738cc2f1a19 (patch)
tree1c72301771f58e3f6902e8fed2ce60d76d231755 /pkgs/build-support/fetchbzr
parent58744ab7f30ccf995864705e222bc93954105af7 (diff)
downloadnixpkgs-224ff6c1eee1e282465b2a715e3f9738cc2f1a19.tar
nixpkgs-224ff6c1eee1e282465b2a715e3f9738cc2f1a19.tar.gz
nixpkgs-224ff6c1eee1e282465b2a715e3f9738cc2f1a19.tar.bz2
nixpkgs-224ff6c1eee1e282465b2a715e3f9738cc2f1a19.tar.lz
nixpkgs-224ff6c1eee1e282465b2a715e3f9738cc2f1a19.tar.xz
nixpkgs-224ff6c1eee1e282465b2a715e3f9738cc2f1a19.tar.zst
nixpkgs-224ff6c1eee1e282465b2a715e3f9738cc2f1a19.zip
added nix-prefetch-bzr
svn path=/nixpkgs/trunk/; revision=25806
Diffstat (limited to 'pkgs/build-support/fetchbzr')
-rwxr-xr-xpkgs/build-support/fetchbzr/nix-prefetch-bzr79
1 files changed, 79 insertions, 0 deletions
diff --git a/pkgs/build-support/fetchbzr/nix-prefetch-bzr b/pkgs/build-support/fetchbzr/nix-prefetch-bzr
new file mode 100755
index 00000000000..167892fbb79
--- /dev/null
+++ b/pkgs/build-support/fetchbzr/nix-prefetch-bzr
@@ -0,0 +1,79 @@
+#! /bin/sh -e
+
+url=$1
+rev=$2
+expHash=$3
+
+hashType=$NIX_HASH_ALGO
+if test -z "$hashType"; then
+    hashType=sha256
+fi
+if test -z "$hashFormat"; then
+    hashFormat=--base32
+fi
+
+if test -z "$url"; then
+    echo "syntax: nix-prefetch-bzr URL [REVISION [EXPECTED-HASH]]" >&2
+    exit 1
+fi
+
+revarg="-r $rev"
+test -n "$rev" || revarg=""
+
+repoName=$(echo $url | sed '
+  s,.*/\([^/]\+\)/trunk/*$,\1,;t
+  s,.*/\([^/]\+\)/branches/\([^/]\+\)/*$,\1-\2,;t
+  s,.*/\([^/]\+\)/tags/\([^/]\+\)/*$,\1-\2,;t
+  s,.*/\([^/]\+\)/*$,\1,;t
+')
+dstFile=$repoName-r$rev
+test -n "$rev" || dstFile=$repoName
+
+# If the hash was given, a file with that hash may already be in the
+# store.
+if test -n "$expHash"; then
+    finalPath=$(nix-store --print-fixed-path --recursive "$hashType" "$expHash" $dstFile)
+    if ! nix-store --check-validity "$finalPath" 2> /dev/null; then
+        finalPath=
+    fi
+    hash=$expHash
+fi
+
+
+# If we don't know the hash or a path with that hash doesn't exist,
+# download the file and add it to the store.
+if test -z "$finalPath"; then
+    tmpPath=/tmp/bzr-checkout-tmp-$$
+    tmpFile=$tmpPath/$dstFile
+    mkdir $tmpPath
+
+    trap "rm -rf $tmpPath" EXIT
+
+    # Perform the checkout.
+    if test "$NIX_PREFETCH_BZR_LEAVE_DOT_BZR" != 1
+    then
+        bzr export $revarg "$tmpFile" "$url" >&2
+    else
+        bzr checkout --lightweight $revarg "$url" "$tmpFile" >&2
+    fi
+
+    # Compute the hash.
+    hash=$(nix-hash --type $hashType $hashFormat $tmpFile)
+    if ! test -n "$QUIET"; then echo "hash is $hash" >&2; fi
+
+    # Add the downloaded file to the Nix store.
+    finalPath=$(nix-store --add-fixed --recursive "$hashType" $tmpFile)
+
+    if test -n "$expHash" -a "$expHash" != "$hash"; then
+        echo "hash mismatch for URL \`$url'"
+        exit 1
+    fi
+fi
+
+if ! test -n "$QUIET"; then echo "path is $finalPath" >&2; fi
+
+echo $hash
+
+if test -n "$PRINT_PATH"; then
+    echo $finalPath
+fi